#! /bin/sh
# -*- coding: utf-8 -*-
# Copyright (C) 2008, 2011, 2012 Laboratoire de Recherche et
# Développement de l'Epita (LRDE).
# Copyright (C) 2004, 2005 Laboratoire d'Informatique de Paris 6
# (LIP6), département Systèmes Répartis Coopératifs (SRC), Université
# Pierre et Marie Curie.
#
# This file is part of Spot, a model checking library.
#
# Spot is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# Spot is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
# License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Check that each header is self contained and generates no warning.

set -e

rm -f failures

# Remove any trailing slash
INCDIR=${INCDIR%/}

for file in `find "$INCDIR" \( -name "${1-*}.hh" \
                               -o -name "${1-*}.hxx" \) \
                  -a -type f -a -print | sed "s,$INCDIR/,,g"`; do

   b=`echo "$file" | tr '[/.a-z]' '[__A-Z]'`
   if grep "[	 ]*#.*def.* SPOT_$b\$" "$INCDIR/$file" >/dev/null; then
     :
   elif grep 'GNU Bison 2\.6' "$INCDIR/$file" >/dev/null; then
     # Bison 2.6, 2.6.1, 2.6.2 have a bug where position.hh
     # include <iosfwd> instead of <iostream>.
     continue
   elif grep 'GNU Bison' "$INCDIR/$file" >/dev/null; then
     :
   else
     echo "Missing, or incorrect include guard." >&2
     echo "FAIL: $file"
     echo "  $file" >> failures
     continue
   fi

   cat >incltest.cc <<EOF
// Include the file twice, so we detect missing inclusion guards.
#include <$file>
#include <$file>
EOF

   case $file in
    *bin/*) MOREFLAGS="-I $TOPBUILD/lib/ -I $INCDIR/../lib/ -I $TOPBUILD";;
    *) MOREFLAGS=;;
   esac

   if $CXX $MOREFLAGS $CPPFLAGS -DSKIP_DEPRECATED_WARNING $CXXFLAGS -c incltest.cc; then
      echo "PASS: $file"
   else
      echo "FAIL: $file"
      echo "  $file" >> failures
   fi
done

if test -f failures; then
   echo "Failed files:"
   cat failures
   rm failures
   exit 1;
fi
